(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["provideTheme"] = factory();
	else
		root["provideTheme"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	exports.__esModule = true;

	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

	var _reduxThunk = __webpack_require__(2);

	var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

	var _exenv = __webpack_require__(1);

	var SET_THEMES = 'SET_THEMES';
	exports.SET_THEMES = SET_THEMES;
	var SET_THEMES_FILES = 'SET_THEMES_FILES';
	exports.SET_THEMES_FILES = SET_THEMES_FILES;
	var INIT_THEME = 'INIT_THEME';
	exports.INIT_THEME = INIT_THEME;
	var LOAD_THEME = 'LOAD_THEME';

	exports.LOAD_THEME = LOAD_THEME;
	var getPathname = function getPathname(href) {
	  try {
	    return new URL(href).pathname;
	  } catch (error) {
	    return error;
	  }
	};

	var actions = {
	  setThemes: function setThemes(themes) {
	    return { type: SET_THEMES, themes: themes };
	  },

	  setThemesFiles: function setThemesFiles(themesFiles) {
	    return { type: SET_THEMES_FILES, themesFiles: themesFiles };
	  },

	  initTheme: function initTheme(themeName, themeFiles, theme) {
	    var jsFile = themeFiles.jsFile;
	    var cssFile = themeFiles.cssFile;

	    var links = null;
	    var link = null;
	    var scripts = null;
	    var script = null;
	    var index = -1;
	    var href = null;

	    if (_exenv.canUseDOM) {
	      links = document.getElementsByTagName('link');
	      index = links.length;

	      while (--index >= 0) {
	        href = links[index].href;
	        if (href === cssFile || getPathname(href) === cssFile) {
	          link = links[index];
	          break;
	        }
	      }

	      scripts = document.getElementsByTagName('script');
	      index = scripts.length;

	      while (--index >= 0) {
	        href = scripts[index].src;
	        if (href === jsFile || getPathname(href) === jsFile) {
	          script = scripts[index];
	          break;
	        }
	      }
	    }

	    return { type: INIT_THEME, themeName: themeName, theme: theme, link: link, script: script };
	  },

	  loadTheme: function loadTheme(themeName, themeFiles) {
	    var jsFile = themeFiles.jsFile;
	    var cssFile = themeFiles.cssFile;

	    var script = null;
	    var link = null;
	    var theme = null;

	    if (_exenv.canUseDOM) {
	      return function (dispatch) {
	        link = document.createElement('link');
	        document.head.appendChild(link);
	        link.rel = 'stylesheet';
	        link.type = 'text/css';
	        link.href = cssFile;

	        script = document.createElement('script');
	        document.head.appendChild(script);
	        script.type = 'text/javascript';
	        script.onload = function () {
	          theme = window[themeName]['default'] || window[themeName];
	          dispatch({ type: LOAD_THEME, themeName: themeName, theme: theme, link: link, script: script });
	        };
	        script.src = jsFile;
	      };
	    } else {
	      return function (dispatch, getState) {
	        var _getState = getState();

	        var themes = _getState.themes;

	        theme = themes && themes[themeName] || null;
	        dispatch({ type: LOAD_THEME, themeName: themeName, theme: theme, link: link, script: script });
	      };
	    }
	  }
	};

	var reducers = {
	  themes: function themes(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case SET_THEMES:
	        return action.themes;

	      default:
	        return state;
	    }
	  },

	  themesFiles: function themesFiles(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case SET_THEMES_FILES:
	        return action.themesFiles;

	      default:
	        return state;
	    }
	  },

	  themeName: function themeName(state, action) {
	    if (state === undefined) state = null;

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        return action.themeName;

	      default:
	        return state;
	    }
	  },

	  theme: function theme(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        return action.theme || {};

	      default:
	        return state;
	    }
	  },

	  classes: function classes(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        return action.theme && action.theme.classes || {};

	      default:
	        return state;
	    }
	  },

	  images: function images(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        return action.theme && action.theme.images || {};

	      default:
	        return state;
	    }
	  },

	  icons: function icons(state, action) {
	    if (state === undefined) state = {};

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        return action.theme && action.theme.icons || {};

	      default:
	        return state;
	    }
	  },

	  link: function link(state, action) {
	    if (state === undefined) state = null;
	    var link = action.link;

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        if (state && state.parentNode && state !== link) {
	          state.parentNode.removeChild(state);
	        }
	        return link || null;

	      default:
	        return _exenv.canUseDOM && state instanceof HTMLElement ? state : null;
	    }
	  },

	  script: function script(state, action) {
	    if (state === undefined) state = null;
	    var script = action.script;

	    switch (action.type) {
	      case INIT_THEME:
	      case LOAD_THEME:
	        if (state && state.parentNode && state !== script) {
	          state.parentNode.removeChild(state);
	        }
	        return script || null;

	      default:
	        return _exenv.canUseDOM && state instanceof HTMLElement ? state : null;
	    }
	  }
	};

	var enhancer = function enhancer(next) {
	  return function (reducer, initialState) {
	    var store = next(reducer, initialState);
	    var state = initialState || {};
	    var themes = state.themes;
	    var themesFiles = state.themesFiles;
	    var themeName = state.themeName;

	    var theme = state.theme || themes && themes[themeName];
	    var themeFiles = themesFiles && themesFiles[themeName];
	    var initAction = null;

	    if (theme || themeFiles) {
	      initAction = theme && actions.initTheme(themeName, themeFiles, theme);

	      if (initAction && (!_exenv.canUseDOM || initAction.link && initAction.script)) {
	        store.dispatch(initAction);
	      } else if (_exenv.canUseDOM) {
	        actions.loadTheme(themeName, themeFiles)(store.dispatch);
	      } else {
	        store.dispatch(actions.loadTheme(themeName, themeFiles));
	      }
	    }

	    return store;
	  };
	};

	var middleware = _reduxThunk2['default'];

	exports['default'] = { actions: actions, reducers: reducers, enhancer: enhancer, middleware: middleware };

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/*!
	  Copyright (c) 2015 Jed Watson.
	  Based on code that is Copyright 2013-2015, Facebook, Inc.
	  All rights reserved.
	*/

	(function () {
		'use strict';

		var canUseDOM = !!(
			typeof window !== 'undefined' &&
			window.document &&
			window.document.createElement
		);

		var ExecutionEnvironment = {

			canUseDOM: canUseDOM,

			canUseWorkers: typeof Worker !== 'undefined',

			canUseEventListeners:
				canUseDOM && !!(window.addEventListener || window.attachEvent),

			canUseViewport: canUseDOM && !!window.screen

		};

		if (true) {
			!(__WEBPACK_AMD_DEFINE_RESULT__ = function () {
				return ExecutionEnvironment;
			}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else if (typeof module !== 'undefined' && module.exports) {
			module.exports = ExecutionEnvironment;
		} else {
			window.ExecutionEnvironment = ExecutionEnvironment;
		}

	}());


/***/ },
/* 2 */
/***/ function(module, exports) {

	'use strict';

	function thunkMiddleware(_ref) {
	  var dispatch = _ref.dispatch;
	  var getState = _ref.getState;

	  return function (next) {
	    return function (action) {
	      return typeof action === 'function' ? action(dispatch, getState) : next(action);
	    };
	  };
	}

	module.exports = thunkMiddleware;

/***/ }
/******/ ])
});
;